<template>

  <q-btn v-if="this.$store.state.oidcUser.authenticated" flat class="bg-accent fit">
    <q-avatar v-if="this.$store.state.oidcUser.oidcUser.email=='weasel@tutamail.com'">
      <img src="~assets/MarkPassFoto.jpg">
    </q-avatar>
    <q-avatar v-else :icon = "`img:${gateway}/api/img/image/${oidcUser.email}`"></q-avatar>
    <q-menu fit>
      <div class="row no-wrap q-pa-md justify-around bg-accent text-white">
          <q-form :action="`${gateway}/logout`" method="post" @submit="logout">
            <input name="_csrf" type="hidden" v-bind:value="csrf">
            <q-btn color="secondary" flat no-caps label="Logout" v-close-popup class="full-width" type="submit"></q-btn>
            <div class="row no-wrap q-pa-md justify-around bg-accent text-white">
              <q-item clickable tag="a" target="_blank" href="https://auth.haberpursch.dev/auth/realms/haberpursch.dev/account/#/">
                  <q-item-section>
                      <q-item-label>account settings</q-item-label>
                  </q-item-section>
              </q-item>
            </div>
          </q-form>
          <!--<q-btn color="secondary" flat no-caps label="Logout" v-close-popup class="full-width" @click="logoutjs"></q-btn>-->
      </div>
    </q-menu>
  </q-btn>
  

  <q-btn v-else flat no-caps icon="account_circle" class="bg-secondary fit" >
    <q-menu fit>
      <div class="row no-wrap q-pa-md justify-around bg-accent text-white">
          <q-btn color="secondary" flat no-caps label="Login" v-close-popup @click="login" class="full-width"></q-btn>
      </div>
    </q-menu>
  </q-btn>

</template>

<script>
import { gateway_url } from "src/assets/custom";
export default {
  name: 'AccountButton',
  data() {
    return {
      gateway: gateway_url 
    }
  },
  methods:{
    login() {
      window.location.href = gateway_url+"/oauth2/authorization/keycloak";
    },
    logout(evt) {// I think this entire function is not even executed, doublecheck!
      evt.target.submit();
    },
    // async logoutjs(){
    //   var formData = new FormData();
    //   formData.append("_csrf", this.$store.state.oidcUser.csrftoken );
    //   await this.$store.dispatch( 'oidcUser/logoutjs', formData );

    // }
  },
  async beforeCreate(){
    // Store the csrf as soon as possible into vuex
    this.$store.commit('oidcUser/setCsrftoken', this.$q.cookies.get('XSRF-TOKEN') );
  },
  computed: {
    // Constantly update current CSRFToken to the VuexStore for Axios to be able to make requests with it.
    csrf:{
        get(){
            return this.$q.cookies.get('XSRF-TOKEN');
        },
        set(val){ // This will be triggered when you click on the Tabs!
            this.$store.commit('oidcUser/setCsrftoken', val );
        }
    },
    oidcUser: function(){
      return this.$store.state.oidcUser.oidcUser;      
    }
  },
}
</script>
